var path = require('path');

module.exports = function (app) {
  var routes = [
    // Ressources
    {
      method: 'GET',
      path: '/static/{path*}',
      handler: { directory: { path: __dirname + '/../public', listing: false, index: true } },
      config: { auth: false, plugins: { crumb: false, friendlyErrors: false } }
    },
    // Index controller
    {
      method: 'GET', path: '/',
      handler: app.execute.bind(app, 'index', 'index'),
      config: { auth: false, plugins: { crumb: false } }
    },
    {
      method: 'GET', path: '/secret',
      handler: app.execute.bind(app, 'index', 'secret'),
      config: { auth: false, plugins: { crumb: false } }
    },
    // User controller
    {
      method: 'GET', path: '/user/logout',
      handler: function (request, reply) {
        request.session._logout();
        reply('Redirecting').redirect('/');
      },
      config: { auth: 'passport', plugins: { friendlyErrors: false, crumb: false } }
    },
    {
      method: '*', path: '/user/login',
      handler: app.execute.bind(app, 'user', 'login'),
      config: { auth: false }
    },
    {
      method: '*', path: '/user/login/facebook',
      handler: app.execute.bind(app, 'user', 'facebookLogin'),
      config: { auth: false, plugins: { crumb: false, friendlyErrors: false } }
    },
    {
      method: '*', path: '/user/login/twitter',
      handler: app.execute.bind(app, 'user', 'twitterLogin'),
      config: { auth: false, plugins: { crumb: false, hapi18n: false, friendlyErrors: false } }
    },
    {
      method: '*', path: '/user/login/facebook/callback',
      handler: app.execute.bind(app, 'user', 'facebookLoginCallback'),
      config: { auth: false, plugins: { crumb: false, hapi18n: false, friendlyErrors: false } }
    },
    {
      method: '*', path: '/user/login/twitter/callback',
      handler: app.execute.bind(app, 'user', 'twitterLoginCallback'),
      config: { auth: false, plugins: { crumb: false, hapi18n: false, friendlyErrors: false } }
    }
  ];
  return routes;
};