var path = require('path'),
  _ = require('lodash'),
  Ejs = require('ejs');

// Customize template engine for Hapi
Ejs.registerHelper = function(name, fn) {
  Ejs.filters[name] = fn;
};

var host = "0.0.0.0",
    port = process.env.PORT || 3001,
    url = 'http://localhost:3001';

module.exports = {
  app: {
    name: 'myTravelogueApp',
    host: host,
    port: port,
    url: url,
    path: __dirname + '/../',
    routes: require('./routes'),
    menu: require('./menu'),
    errorTemplate: 'error/main',
    start: require('./init/auth'),
    init: require('./init/data')
  },
  plugins: require('./plugins')(host, port, url),
  views: {
    engines: {
      html: {
        module: Ejs
      }
    },
    path: __dirname + '/../views',
    layout: true,
    layoutKeyword: 'body'
  },
  cache: {
    engine: 'catbox-memory'
  },
  debug: { request: ['error', 'uncaught'] }
};