var _ = require('lodash')
  , Joi = require('joi');

/**
 * Base controller
 * @type {Function}
 */
var Controller = module.exports = function Controller(app, settings) {
  if (app)  {
    this.app = app;
    this.settings = settings;
  } else {
    this.settings = app;
  }
  return this;
};

_.extend(
  Controller.prototype,
  {

    validateRequest: function (params, schema) {
      return this.convertJoiErrors(
        Joi.validate(
          params,
          schema
        )
      );
    },

    convertJoiErrors: function (errors) {
      var fieldErrors = {};
      if (_.has(errors, '_errors') && _.isArray(errors._errors)) {
        for (i = 0, l = errors._errors.length; i< l; i++) {
          fieldErrors[ errors._errors[i].path ] =
            errors._errors[i].message.charAt(0).toUpperCase() +
              errors._errors[i].message.substr(1)
        }
      }
      return fieldErrors;
    }

  }
);