var _ = require('lodash')
  , fs = require('fs')
  , crypto = require('crypto');

/**
 * Assets Cooker
 * @type {Function}
 */
var Hasher = module.exports = function Hasher() {};

_.extend(
  Hasher.prototype,
  {
    /**
     * Takes the sha1 sum of a file
     * @param path File path
     * @param callback
     */
    sumFile:  function (path, callback) {
      var shasum = crypto.createHash('sha1');
      fs.ReadStream(path).on(
        'data',
        function(d) {
          shasum.update(d);
        }
      ).on(
        'end',
        function() {
          callback(
            shasum.digest('hex')
          );
        }
      );
    },

    /**
     * Takes the sha1 sum of some string
     * @param content String
     * @param callback
     */
    sumString: function (content, secondString) {
      if (secondString) {
        content = this.sumString(content) +
          this.sumString(secondString);
      }
      var shasum = crypto.createHash('sha1').update(
        content.toString()
      );
      return shasum.digest('hex').substr(0, 8);
    }
  }
);
